# all files / ol/geom/ linestring.js

87.5% Statements 70/80
55.56% Branches 10/18
80% Functions 12/15
87.5% Lines 70/80

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    2711×

    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    306×

    306×

    306×

    306×

    306×

    306×

    1×

    1×
    2×

    2×

    2×

    2×

    1×
    25×
    25×
    25×

    1×

    1×

    1×
    57×

    57×
    57×

    1×
    143×

    1×
    8×

    1×

    1×
    2×
    2×
    2×

    2×

    1×
    9×
    9×

    9×
    9×

    9×

    1×
    68×

    1×
    14×

    1×
    372×
    121×

    251×
    251×
    185×

    251×

    251×

    1×
    243×
    243×

     goog.provide('ol.geom.LineString');

    goog.require('goog.asserts');
    goog.require('ol');
    goog.require('ol.array');
    goog.require('ol.extent');
    goog.require('ol.geom.GeometryLayout');
    goog.require('ol.geom.GeometryType');
    goog.require('ol.geom.SimpleGeometry');
    goog.require('ol.geom.flat.closest');
    goog.require('ol.geom.flat.deflate');
    goog.require('ol.geom.flat.inflate');
    goog.require('ol.geom.flat.interpolate');
    goog.require('ol.geom.flat.intersectsextent');
    goog.require('ol.geom.flat.length');
    goog.require('ol.geom.flat.segments');
    goog.require('ol.geom.flat.simplify');

    /**
     * @classdesc
     * Linestring geometry.
     *
     * @constructor
     * @extends {ol.geom.SimpleGeometry}
     * @param {Array.<ol.Coordinate>} coordinates Coordinates.
     * @param {ol.geom.GeometryLayout=} opt_layout Layout.
     * @api stable
     */
    ol.geom.LineString = function(coordinates, opt_layout) {

      goog.base(this);

      /**
       * @private
       * @type {ol.Coordinate}
       */
      this.flatMidpoint_ = null;

      /**
       * @private
       * @type {number}
       */
      this.flatMidpointRevision_ = -1;

      /**
       * @private
       * @type {number}
       */
      this.maxDelta_ = -1;

      /**
       * @private
       * @type {number}
       */
      this.maxDeltaRevision_ = -1;

      this.setCoordinates(coordinates, opt_layout);

    };
    goog.inherits(ol.geom.LineString, ol.geom.SimpleGeometry);

    /**
     * Append the passed coordinate to the coordinates of the linestring.
     * @param {ol.Coordinate} coordinate Coordinate.
     * @api stable
     */
    ol.geom.LineString.prototype.appendCoordinate = function(coordinate) {
      goog.asserts.assert(coordinate.length == this.stride,
          'length of coordinate array should match stride');
      Iif (!this.flatCoordinates) {
        this.flatCoordinates = coordinate.slice();
      } else {
        ol.array.extend(this.flatCoordinates, coordinate);
      }
      this.changed();
    };

    /**
     * Make a complete copy of the geometry.
     * @return {!ol.geom.LineString} Clone.
     * @api stable
     */
    ol.geom.LineString.prototype.clone = function() {
      var lineString = new ol.geom.LineString(null);
      lineString.setFlatCoordinates(this.layout, this.flatCoordinates.slice());
      return lineString;
    };

    /**
     * @inheritDoc
     */
    ol.geom.LineString.prototype.closestPointXY = function(x, y, closestPoint, minSquaredDistance) {
      if (minSquaredDistance <
          ol.extent.closestSquaredDistanceXY(this.getExtent(), x, y)) {
        return minSquaredDistance;
      }
      if (this.maxDeltaRevision_ != this.getRevision()) {
        this.maxDelta_ = Math.sqrt(ol.geom.flat.closest.getMaxSquaredDelta(
            this.flatCoordinates, 0, this.flatCoordinates.length, this.stride, 0));
        this.maxDeltaRevision_ = this.getRevision();
      }
      return ol.geom.flat.closest.getClosestPoint(
          this.flatCoordinates, 0, this.flatCoordinates.length, this.stride,
          this.maxDelta_, false, x, y, closestPoint, minSquaredDistance);
    };

    /**
     * Iterate over each segment, calling the provided callback.
     * If the callback returns a truthy value the function returns that
     * value immediately. Otherwise the function returns `false`.
     *
     * @param {function(this: S, ol.Coordinate, ol.Coordinate): T} callback Function
     *     called for each segment.
     * @param {S=} opt_this The object to be used as the value of 'this'
     *     within callback.
     * @return {T|boolean} Value.
     * @template T,S
     * @api
     */
    ol.geom.LineString.prototype.forEachSegment = function(callback, opt_this) {
      return ol.geom.flat.segments.forEach(this.flatCoordinates, 0,
          this.flatCoordinates.length, this.stride, callback, opt_this);
    };

    /**
     * Returns the coordinate at `m` using linear interpolation, or `null` if no
     * such coordinate exists.
     *
     * `opt_extrapolate` controls extrapolation beyond the range of Ms in the
     * MultiLineString. If `opt_extrapolate` is `true` then Ms less than the first
     * M will return the first coordinate and Ms greater than the last M will
     * return the last coordinate.
     *
     * @param {number} m M.
     * @param {boolean=} opt_extrapolate Extrapolate. Default is `false`.
     * @return {ol.Coordinate} Coordinate.
     * @api stable
     */
    ol.geom.LineString.prototype.getCoordinateAtM = function(m, opt_extrapolate) {
      Iif (this.layout != ol.geom.GeometryLayout.XYM &&
          this.layout != ol.geom.GeometryLayout.XYZM) {
        return null;
      }
      var extrapolate = opt_extrapolate !== undefined ? opt_extrapolate : false;
      return ol.geom.flat.lineStringCoordinateAtM(this.flatCoordinates, 0,
          this.flatCoordinates.length, this.stride, m, extrapolate);
    };

    /**
     * Return the coordinates of the linestring.
     * @return {Array.<ol.Coordinate>} Coordinates.
     * @api stable
     */
    ol.geom.LineString.prototype.getCoordinates = function() {
      return ol.geom.flat.inflate.coordinates(
          this.flatCoordinates, 0, this.flatCoordinates.length, this.stride);
    };

    /**
     * Return the coordinate at the provided fraction along the linestring.
     * The `fraction` is a number between 0 and 1, where 0 is the start of the
     * linestring and 1 is the end.
     * @param {number} fraction Fraction.
     * @param {ol.Coordinate=} opt_dest Optional coordinate whose values will
     *     be modified. If not provided, a new coordinate will be returned.
     * @return {ol.Coordinate} Coordinate of the interpolated point.
     * @api
     */
    ol.geom.LineString.prototype.getCoordinateAt = function(fraction, opt_dest) {
      return ol.geom.flat.interpolate.lineString(
          this.flatCoordinates, 0, this.flatCoordinates.length, this.stride,
          fraction, opt_dest);
    };

    /**
     * Return the length of the linestring on projected plane.
     * @return {number} Length (on projected plane).
     * @api stable
     */
    ol.geom.LineString.prototype.getLength = function() {
      return ol.geom.flat.length.lineString(
          this.flatCoordinates, 0, this.flatCoordinates.length, this.stride);
    };

    /**
     * @return {Array.<number>} Flat midpoint.
     */
    ol.geom.LineString.prototype.getFlatMidpoint = function() {
      Eif (this.flatMidpointRevision_ != this.getRevision()) {
        this.flatMidpoint_ = this.getCoordinateAt(0.5, this.flatMidpoint_);
        this.flatMidpointRevision_ = this.getRevision();
      }
      return this.flatMidpoint_;
    };

    /**
     * @inheritDoc
     */
    ol.geom.LineString.prototype.getSimplifiedGeometryInternal = function(squaredTolerance) {
      var simplifiedFlatCoordinates = [];
      simplifiedFlatCoordinates.length = ol.geom.flat.simplify.douglasPeucker(
          this.flatCoordinates, 0, this.flatCoordinates.length, this.stride,
          squaredTolerance, simplifiedFlatCoordinates, 0);
      var simplifiedLineString = new ol.geom.LineString(null);
      simplifiedLineString.setFlatCoordinates(
          ol.geom.GeometryLayout.XY, simplifiedFlatCoordinates);
      return simplifiedLineString;
    };

    /**
     * @inheritDoc
     * @api stable
     */
    ol.geom.LineString.prototype.getType = function() {
      return ol.geom.GeometryType.LINE_STRING;
    };

    /**
     * @inheritDoc
     * @api stable
     */
    ol.geom.LineString.prototype.intersectsExtent = function(extent) {
      return ol.geom.flat.intersectsextent.lineString(
          this.flatCoordinates, 0, this.flatCoordinates.length, this.stride,
          extent);
    };

    /**
     * Set the coordinates of the linestring.
     * @param {Array.<ol.Coordinate>} coordinates Coordinates.
     * @param {ol.geom.GeometryLayout=} opt_layout Layout.
     * @api stable
     */
    ol.geom.LineString.prototype.setCoordinates = function(coordinates, opt_layout) {
      if (!coordinates) {
        this.setFlatCoordinates(ol.geom.GeometryLayout.XY, null);
      } else {
        this.setLayout(opt_layout, coordinates, 1);
        if (!this.flatCoordinates) {
          this.flatCoordinates = [];
        }
        this.flatCoordinates.length = ol.geom.flat.deflate.coordinates(
            this.flatCoordinates, 0, coordinates, this.stride);
        this.changed();
      }
    };

    /**
     * @param {ol.geom.GeometryLayout} layout Layout.
     * @param {Array.<number>} flatCoordinates Flat coordinates.
     */
    ol.geom.LineString.prototype.setFlatCoordinates = function(layout, flatCoordinates) {
      this.setFlatCoordinatesInternal(layout, flatCoordinates);
      this.changed();
    };